document.write("<script src='/user/misc.js' type='text/javascript'></script>");
document.write("<script src='/user/splash.js' type='text/javascript'></script>");


var xmlhttp;
var xmlhttpSample;

var type;
var doc;
var timeout;
var splashDiv;

var auxInputArray;
var moduleVoltageArray;
var moduleCurrentArray;
var temperatureArray;

var channelId;

var selectionControl;

var calDirty;

var busySplashDiv ;

// Start by requesting the channel settings so we know which curves to ask for.
window.onload = initialize;
window.onunload = calExit;


//////////////////////////////////////////////////////////////////////////////
function initialize()
{
	doc = document;
	var results;
	var text;
	var measuredLabel;


	calDirty = false;
	
	xmlhttp = misc_getXmlRequestObject();
	xmlhttpSample = misc_getXmlRequestObject();
			
	results =  misc_getSearchArray();
	type = results["type"];

	busySplashDiv = getSplash("Mutli-Tracer Busy", "Please wait", document.getElementById('dialog') );
	busySplashDiv.id = "busy_splash";
	busySplashDiv.style.visibility="hidden";
	
	document.getElementById('loadLayer').style.visibility="hidden";
		
	switch (type) {
		case "module_voltage":
			text = "Module Voltage";
			
		break;
		
		case "module_current":
			text = "Module Current";	
			document.getElementById('loadLayer').style.visibility="visible";
		break;

		case "aux_input":
			text = "Aux Input";
		break;
			text  = "Unknown";	

		default:
		
	}//switch on type		

	disableButtons(); //disable critical buttons until initialization is complete
		
	document.getElementById('lblActual').innerHTML = "Actual " + text;
	document.getElementById('lblMeasured').innerHTML = "Measured " + text;	
	document.getElementById('lblSelect').innerHTML =  text + " Channel";	
	
	//Get a sample, to use to configure page
	if (xmlhttpSample!= null){
		xmlhttpSample.open("GET","/user/sample.xml",false);
		xmlhttpSample.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
//		xmlhttpSample.onreadystatechange = onConfigureResponse;  
		timeout = setTimeout(xmlTimeout, 5000);
		xmlhttpSample.send(null);
		onConfigureResponse();

	}else{
		alert("Your browser does not support XMLHTTP.");
	}

	enableButtons(); //disable critical buttons until initialization is complete
}


//////////////////////////////////////////////////////////////////////////////
function onConfigureResponse()
{
	var value;
	var i;
	var id;
	var temperatures;
	var modules;
	var aux_inputs;

	if(xmlhttpSample.readyState != 4){
		return;
	}
	
	if(xmlhttpSample.status == 0 ){
		//Ststus that seems to happen when we close a page with a pending request.
		return;
	}
	
	if(xmlhttpSample.status != 200){
		alert("Problem retrieving XML data");
		return;
	}
	
	clearXmlTimeout();


	processSampleResponse();
	
	//configure page elements based on configuraton
	selectionControl = document.getElementById('channelSelect');


	var dataArray;
	//Use the data based on teh type of calibraiton we are doing
	switch (type) {
		case "module_voltage":
			dataArray= moduleVoltageArray;
			break;
		
		case "module_current":
			dataArray= moduleCurrentArray;
			break;

		case "aux_input":
			dataArray= auxInputArray;
			break;
		default:
			dataArray=null;
	}//switch on type


	if( dataArray!= null ) {
		selectionControl.options.length = 0; //empty seleciton otpions
		//iterate through each element in array and add an option to teh seleciton control
		for (var key in dataArray) {
			selectionControl.options[selectionControl.options.length] = new Option(key, key);
		}
	}
	
	selectionControl.selectedIndex = 0;
	onSelectionChanged()
	
	
	loadsOff();
	
	//initiate sampling
	getNextSample();
	
//	enableButtons();
}


//////////////////////////////////////////////////////////////////////////
// Channel seleciton has changed
function onSelectionChanged()
{
	channelId = selectionControl.options[selectionControl.selectedIndex].value;
}

//////////////////////////////////////////////////////////////////////////
function nextSignal()
{
	var index = selectionControl.selectedIndex;
	index = index + 1;
	if ( index >= selectionControl.options.length ) {
		index = 0;
	}
	
	//Automatically turn loads off when switching to next channel. Only applies to
	//modukle current calibration
	if( type == "module_current" ) {
		document.getElementById("load_on").checked = false; 
		loadsOff();		
	}
	
	selectionControl.selectedIndex = index;
	onSelectionChanged();

	//clear measured, but leave actual alone since user will likely use
	//the same value again.
	document.getElementById('measuredInput').value = " ";
}

//////////////////////////////////////////////////////////////////////////
function calibrate(adjust)
{
	var actualValue = document.getElementById('actualInput').value;
	
	disableButtons();
		
	//create an XML document to send back settings
	xmlhttpDoc = misc_createXmlDoc();
	
	var root = xmlhttpDoc.createElement("Calibration");
	xmlhttpDoc.appendChild(root );
	
	root.setAttribute("type", type  );
	root.setAttribute("id", channelId);
	root.setAttribute("actual", actualValue );	
	root.setAttribute("adjust", adjust );	
	
	//any time we adjust the calibraiton, it is now dirty and requires saving
	if( adjust == 1 ) {
		calDirty = true ; 
	}
	
	if (xmlhttp!=null){
		xmlhttp.open("POST","/admin/calibrate",false);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
//		xmlhttp.onreadystatechange = onCalibrateResponse;  //read back settings
		timeout = setTimeout(xmlTimeout, 2000);//
		xmlhttp.send(xmlhttpDoc);


		onCalibrateResponse();

	}else{
		alert("Your browser does not support XMLHTTP.");
	}
	enableButtons();
}

//////////////////////////////////////////////////////////////////////////////
function onCalibrateResponse()
{
	if(xmlhttp.readyState!=4){
		return;
	}
	
	if(xmlhttp.status == 0 ){
		//Status that seems to happen when we close a page with a pending request.
		return;
	}

	if(xmlhttp.status!=200){
		alert("Problem retrieving XML data");
		enableButtons();
		return;
	}
	
	clearXmlTimeout();

//	alert("Cal done");
	
//	enableButtons();
} //onClibrateResponse






//////////////////////////////////////////////////////////////////////////
function loadsOff()
{
	var actualValue = document.getElementById('actualInput').value;
		
	disableButtons();
			
	//create an XML document to send back settings
	xmlhttpDoc = misc_createXmlDoc();
	
	var root = xmlhttpDoc .createElement("Calibration");
	xmlhttpDoc.appendChild(root );
	
	root .setAttribute("type", type  );
	root .setAttribute("id", channelId);
	root .setAttribute("actual", actualValue );	

	if (xmlhttp!=null){
		xmlhttp.open("POST","/admin/all_loads_off",false);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
//		xmlhttp.onreadystatechange = onLoadsOffResponse;  //read back settings
		
		timeout = setTimeout(xmlTimeout, 2000);		
		xmlhttp.send(xmlhttpDoc);
		onLoadsOffResponse();

	}else{
		alert("Your browser does not support XMLHTTP.");
	}
	enableButtons();
}// Loads Off

//////////////////////////////////////////////////////////////////////////////
function onLoadsOffResponse()
{
	if(xmlhttp.readyState!=4){
		return;
	}
	
	if(xmlhttp.status == 0 ){
		//Ststus that seems to happen when we close a page with a pending request.
		return;
	}

	if(xmlhttp.status!=200){
		alert("Problem retrieving XML data");
		return;
	}
	
	clearXmlTimeout();

//	alert("Cal done");
	
} //onLoadsOffResponse






//////////////////////////////////////////////////////////////////////////
function loadChange()
{
	if( document.getElementById("load_on").checked == true ) {
		setModuleToIsc()
	}else{
		loadsOff();
	}
}

//////////////////////////////////////////////////////////////////////////
function setModuleToIsc()
{
	var actualValue = document.getElementById('actualInput').value;
	disableButtons();
	
	//create an XML document to send back settings
	xmlhttpDoc = misc_createXmlDoc();
	
	var root = xmlhttpDoc .createElement("SetModuleToIsc");
	xmlhttpDoc.appendChild(root );
	
	root .setAttribute("id", channelId);

	if (xmlhttp!=null){
		xmlhttp.open("POST","/admin/set_module_isc",false);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
//		xmlhttp.onreadystatechange = onLoadsOffResponse;  //read back settings

		timeout = setTimeout(xmlTimeout, 2000);
		xmlhttp.send(xmlhttpDoc);
		onSetModuleToIsc();
	}else{
		alert("Your browser does not support XMLHTTP.");
	}
	enableButtons();
}// Loads Off

//////////////////////////////////////////////////////////////////////////////
function onSetModuleToIsc()
{
	if(xmlhttp.readyState!=4){
		return;
	}
	
	if(xmlhttp.status == 0 ){
		//Ststus that seems to happen when we close a page with a pending request.
		return;
	}

	if(xmlhttp.status!=200){
		alert("Problem retrieving XML data");
		return;
	}
	
	clearXmlTimeout();

//	alert("Cal done");
	
} //onSetModuleToIsc



//////////////////////////////////////////////////////////////////////////
function saveCalibration()
{
	//create an XML document to send back settings
	xmlhttpDoc = misc_createXmlDoc();
	
	var root = xmlhttpDoc .createElement("SaveCalibration");
	xmlhttpDoc.appendChild(root );
	
	root.setAttribute("type", type  );
	
	if (xmlhttp!=null){
		xmlhttp.open("POST","/admin/save_calibration",false);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
//		xmlhttp.onreadystatechange = onSaveCalibrationResponse;  //read back settings

		timeout = setTimeout(xmlTimeout, 2000);
		xmlhttp.send(xmlhttpDoc);
		onSaveCalibrationResponse();

	}else{
		alert("Your browser does not support XMLHTTP.");
	}

}

//////////////////////////////////////////////////////////////////////////////
function onSaveCalibrationResponse()
{
	if(xmlhttp.readyState!=4){
		return;
	}
	
	if(xmlhttp.status == 0 ){
		//Ststus that seems to happen when we close a page with a pending request.
		return;
	}

	if(xmlhttp.status!=200){
		alert("Problem retrieving XML data");
		return;
	}
	
	clearXmlTimeout();


	var results = xmlhttp.responseXML.getElementsByTagName("SaveCalibration");
	var error = null;
	try{	
		error = results[0].getAttribute("error");
	}catch (er) {
	}			

	if( error == "none" ) {
		//save was successful, so clear dirty flag
		calDirty = false ; 
		
	}else{
		alert("Error " + error);
	}


	
} //onSaveClibrateResponse


//////////////////////////////////////////////////////////////////////////
function resetCalibration()
{
	//create an XML document to send back settings
	xmlhttpDoc = misc_createXmlDoc();
	
	var root = xmlhttpDoc .createElement("LoadCalibration");
	xmlhttpDoc.appendChild(root );
	
	root.setAttribute("type", type  );
			
	if (xmlhttp!=null){
		xmlhttp.open("POST","/admin/load_calibration",false);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
//		xmlhttp.onreadystatechange = onResetCalibrationResponse;  //read back settings

		timeout = setTimeout(xmlTimeout, 2000);
		xmlhttp.send(xmlhttpDoc);
		onResetCalibrationResponse();

	}else{
		alert("Your browser does not support XMLHTTP.");
	}

}

//////////////////////////////////////////////////////////////////////////////
function onResetCalibrationResponse()
{

	if(xmlhttp.readyState!=4){
		return;
	}
	
	if(xmlhttp.status == 0 ){
		//Ststus that seems to happen when we close a page with a pending request.
		return;
	}

	if(xmlhttp.status!=200){
		alert("Problem retrieving XML data");
		return;
	}
		
	clearXmlTimeout();


	var results = xmlhttp.responseXML.getElementsByTagName("LoadCalibration");
	var error = null;
	try{	
		error = results[0].getAttribute("error");
	}catch (er) {
	}			
		
	if( error == "none" ) {
		//save was successful, so clear dirty flag
		calDirty = false ; 
		alert("Calibration Reset");
	
	}else{
		alert("Error " + error);
	}

} //onResetClibrateResponse




////////////////////////////////////////////////////////////////////////////////
//
function closeCalibration()
{
	var save = false;
	
	if( calDirty == true ) {
		//prompt user to save
		save = confirm("Save Adjustments?");
		
		if ( save == true ) {
			saveCalibration();
		}
	}

	window.close();

}


////////////////////////////////////////////////////////////////////////////////
//
function cancelCalibration()
{
	resetCalibration(); //reset cal constants to previous values.
	window.close();
}


//////////////////////////////////////////////////////////////////////////////
// Asynchronously request a sample
function getNextSample()
{
	if (xmlhttpSample!= null){
		xmlhttpSample.open("GET","/user/sample.xml",true);
		xmlhttpSample.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
		xmlhttpSample.onreadystatechange = onSampleResponse;  
		xmlhttpSample.send(null);
		timeout = setTimeout(xmlTimeout, 5000);
	}else{
		alert("Your browser does not support XMLHTTP.");
	}
}//getSample


//////////////////////////////////////////////////////////////////////////////
function onSampleResponse()
{
	var value;
	var i;
	var id;
	var temperatures;
	var modules;
	var aux_inputs;
	
	if(xmlhttpSample.readyState != 4){
		return;
	}
	
	if(xmlhttpSample.status == 0 ){
		//Ststus that seems to happen when we close a page with a pending request.
		return;
	}
	
	if(xmlhttpSample.status != 200){
		alert("Problem retrieving XML data");
		return;
	}
		
	clearXmlTimeout();
	
	processSampleResponse();
	

	//Update measurement depending on current type and ID value
	switch (type) {
		case "module_voltage":
			document.getElementById('measuredInput').value = moduleVoltageArray[channelId];
			break;
		
		case "module_current":
			document.getElementById('measuredInput').value = moduleCurrentArray[channelId];	
			break;

		case "aux_input":
			document.getElementById('measuredInput').value = auxInputArray[channelId];	
			break;
		default:
			document.getElementById('measuredInput').value = "N/A";
	}//switch on type

	//set it up to automatically request data
	setTimeout(getNextSample, 500);
} //onSampleResponse


////////////////////////////////////////////////////////////////////////////////
//
function processSampleResponse()
{

	//get temperature data	
	temperatures = xmlhttpSample.responseXML.documentElement.getElementsByTagName("Temp");
	temperatureArray = new Array();			 		 		 			
	for (i=0; i < temperatures.length; i++){	
		try{	
			id=temperatures[i].getAttribute("id");
			value = parseFloat(temperatures[i].getAttribute("value"));
			temperatureArray[id] = value;
		}catch (er) {
		}			
	}//end for i = 

	//get aux input data
	aux_inputs = xmlhttpSample.responseXML.documentElement.getElementsByTagName("Aux");
	auxInputArray = new Array();
	for (i=0; i < aux_inputs.length; i++){	
		try{	
			id = aux_inputs[i].getAttribute("id");
			value = parseFloat(aux_inputs[i].getAttribute("value"));
			auxInputArray[id] = value;		
		}catch (er) {		
		}
			
	}//end for i = 


	//get module data
	modules = xmlhttpSample.responseXML.documentElement.getElementsByTagName("Module");	
	moduleCurrentArray = new Array();
	moduleVoltageArray= new Array();
				 		 		 			
	for (i=0; i < modules .length; i++){	
		try{	
			id = modules[i].getAttribute("id");
			value = parseFloat(modules[i].getAttribute("volts"));
			moduleVoltageArray[id] = value;
			
			value = parseFloat(modules[i].getAttribute("amps"));			
			moduleCurrentArray[id] = value;	
		}catch (er) {			
		}

	}//end for i = 

} //processSampleResponse

////////////////////////////////////////////////////////////////////////////////////////////
function disableButtons()
{
	busySplashDiv.style.visibility="visible";


	document.getElementById('butCalibrate').disabled=true;
	document.getElementById('butCalrecord').disabled=true;
	document.getElementById('butNext').disabled=true;
	document.getElementById('butSave').disabled=true;
	document.getElementById('butCancel').disabled=true;

}
	
////////////////////////////////////////////////////////////////////////////////////////////
function enableButtons()
{
	busySplashDiv.style.visibility="hidden";	
	
	document.getElementById('butCalibrate').disabled=false;
	document.getElementById('butCalrecord').disabled=false;
	document.getElementById('butNext').disabled=false;
	document.getElementById('butSave').disabled=false;
	document.getElementById('butCancel').disabled=false;
}

	
////////////////////////////////////////////////////////////////////////////////////////////
function xmlTimeout()
{
	splashDiv = getSplash("Mutli-Tracer Busy", "Please wait", document.getElementById('dialog') );
	splashDiv.id = "splash";
}

////////////////////////////////////////////////////////////////////////////////////////////
function clearXmlTimeout()
{
	clearTimeout(timeout);
	var splash = document.getElementById('splash') ;	
	if( splash != null ){
		document.getElementById('dialog').removeChild(splash);
	}
}
