

var ID_COLUMN = 0;
var DESCRIPTION_COLUMN = 1;


//Include misc functions
document.write("<script src='/user/misc.js' type='text/javascript'></script>");
document.write("<script src='/admin/settings.js' type='text/javascript'></script>");
document.write("<script src='/user/splash.js' type='text/javascript'></script>");

//global variables
var tempSettings;
var tempTable;

var timeout;
var splashDiv;





// Start by requesting the channel settings so we know which curves to ask for.
window.onload = initialize;

//////////////////////////////////////////////////////////////////////////////
function initialize()
{
	tempSettings= new temperatureSettings();
	
	timeout = setTimeout(xmlTimeout, 2000);			
	tempSettings.getSettings();	//this call blocks	
	clearXmlTimeout();

	
	//create new table
	tempTable = document.createElement("table");
	document.getElementById('tempTableLayer').appendChild(tempTable);	
	tempTable.className = "data_table";
	tempTable.id = "temperature_table";
		
	var caption = tempTable.createCaption();
	caption.innerHTML="Temperatures";

	//Created header row	
	tempTable.createTHead();
	
	var headerRow = tempTable.tHead.insertRow(-1);
	headerRow .className = "data_table_header";
	
	var newCell = headerRow.insertCell(ID_COLUMN);
	newCell.innerHTML =  "ID";
	newCell.className = "data_table_header_cell";
			
	newCell = headerRow.insertCell(DESCRIPTION_COLUMN);
	newCell.innerHTML =  "Description";
	newCell.className = "data_table_header_cell";


  	var tableBody = document.createElement("TBODY");
  	tempTable.appendChild(tableBody);
	updateTable();


} // initialize


//////////////////////////////////////////////////////////////////////////////
//update settings table with current settings
function updateTable()
{
  	var tableBody = tempTable.tBodies[0];

	for ( var i=0; i < tempSettings.channels.length; i++){
		var id;
		var channel = 	tempSettings.channels[i]; //for convenience
		var row = tableBody.rows[i];
		if( row == null ) {
			row = tableBody.insertRow(-1);
			
			//add cell for channel id
			var newCell = row.insertCell(0);
			newCell.className = "data_table_cell";
			
			//add cell for channel description
			newCell = row.insertCell(1);
			newCell.className = "data_table_cell";
			var newInput = document.createElement("input");
			newInput.setAttribute("name","description");
			newInput.setAttribute("type","text");
			newInput.setAttribute("onChange","inputChanged(this)");
			newCell.appendChild(newInput);
		}
		
		row.cells[0].innerHTML = channel.id ;		
		row.cells[1].getElementsByTagName('input')[0].value = channel.description;
	}//end for i = 
}


//////////////////////////////////////////////////////////////////////////////
function inputChanged( inputBox )
{
	//get the table row that this input belongs too
	var row = null;
	var cell = inputBox.parentNode;
	if( cell != null ) {
		row = cell.parentNode;
	}
	
	//if we don't have a row, we don't know what is going on.
	if( row == null ) {
		return;
	}
	
	var idCell = row.cells[ID_COLUMN];
	if( idCell == null ) {
		return; //can't work without id cell;
	}
	
	//finally get id
	var id = idCell.innerHTML;

	//find settigns entry with this id value (could have used row index, but ID is what realy matters)
	for ( var i=0; i < tempSettings.channels.length; i++){
		var channel = 	tempSettings.channels[i]; //for convenience
		
		if( channel.id == id ) {
			channel.description = row.cells[DESCRIPTION_COLUMN].getElementsByTagName('input')[0].value;
			channel.dirty = true;
		}
	}//end for i = 

}// input changed


//////////////////////////////////////////////////////////////////////////////
// Asynchronously set global settings
function setTemperatureSettings()
{	
	//channel data was kept up-to-date when changes were made, so we don't need to do anyting here for that.
	// So simply "set" the settings
	timeout = setTimeout(xmlTimeout, 1000);			
	tempSettings.setSettings();	//this call blocks	
	clearXmlTimeout();
}//set aux settings




////////////////////////////////////////////////////////////////////////////////////////////
function xmlTimeout()
{
	splashDiv = getSplash("Mutli-Tracer Busy", "Please wait", document.getElementById('content_holder') );
	splashDiv.id = "splash";
}

////////////////////////////////////////////////////////////////////////////////////////////
function clearXmlTimeout()
{
	clearTimeout(timeout);
	var splash = document.getElementById('splash') ;	
	if( splash != null ){
		document.getElementById('content_holder').removeChild(splash);
	}
}





